
function [ys,check] = SWNLRamseyIRest_steadystate(ys,exe)
  global M_ options_ oo_ 
  
  mu = 0;     % These initializations are needed because mu,beta and alpha are fonctions of a
  beta = 0;   % matlab toolbox!
  alpha = 0;  % 
  
  
  %%$$ DON'T CHANGE THIS PART
  NumberOfParameters = M_.param_nbr;
  for i = 1:NumberOfParameters
    paramname = deblank(M_.param_names(i,:)); 
    eval([ paramname ' = M_.params(' int2str(i) ');']);    
  end
  check = 0;

  

 

betta_NR  = (1/betta + diff_betta/100)^(-1);
betta_NR_E = (1/betta + diff_betta_E/100)^(-1);
PSISS = 1/betta_NR/(1+((1/betta-1)/(mu_R_D*(1-subv_R_D)))*mu_R_L*(1-subv_R_L));
PSIESS = 1/betta_NR_E/(1+((1/betta-1)/(mu_R_D*(1-subv_R_D)))*mu_R_L_E*(1-subv_R_L_E));


 % -----------------------------------------------------------------------------------------------------
 EE_SIG = 0; EE_SIG_HH = 0;
 OMEG = OMEGSS;
 Z_OMEGS = ( log(OMEG) + 0.5*sigma^2*(exp(EE_SIG*2) ) ) / (sigma*exp(EE_SIG));
 Y_OMEGS = (1 - normcdf(Z_OMEGS))/...
            ( 1 - normcdf(Z_OMEGS) - ...
            mu_NFC*normpdf(Z_OMEGS - sigma*exp(EE_SIG))/(OMEGSS*(sigma*exp(EE_SIG))));
 H_OMEGNS = - ((1 - normcdf(Z_OMEGS))*OMEGSS + normpdf(Z_OMEGS - sigma*exp(EE_SIG)) );
 G_OMEGNS = (1 - normcdf(Z_OMEGS))*OMEGSS + (1 - mu_NFC)*normpdf(Z_OMEGS - sigma*exp(EE_SIG));

 Z_OMEGHHS = ( log(OMEGHHSS) + 0.5*sigma_HH^2*(exp(EE_SIG_HH*2) ) ) / (sigma_HH*exp(EE_SIG_HH));
 Y_OMEGHHS = (1 - normcdf(Z_OMEGHHS))/ ...
                 ( 1 - normcdf(Z_OMEGHHS) - ...
                  mu_HH*normpdf(Z_OMEGHHS - sigma_HH*exp(EE_SIG_HH))/(OMEGHHSS*(sigma_HH*exp(EE_SIG_HH))));
 H_OMEGHHNS = -( (1 - normcdf(Z_OMEGHHS))*OMEGHHSS + normpdf(Z_OMEGHHS - sigma_HH*exp(EE_SIG_HH)) );
 G_OMEGHHNS =  (1 - normcdf(Z_OMEGHHS))*OMEGHHSS + (1 - mu_HH)*normpdf(Z_OMEGHHS - sigma_HH*exp(EE_SIG_HH)) ;               

 Z_OMEG = Z_OMEGS;
 Y_OMEG =  Y_OMEGS;
 H_OMEGN = H_OMEGNS;
 G_OMEGN = G_OMEGNS ;
 Z_OMEGHH = Z_OMEGHHS;
 Y_OMEGHH = Y_OMEGHHS;
 H_OMEGHHN = H_OMEGHHNS ;
 G_OMEGHHN = G_OMEGHHNS;
 % -------------------------------------------------------------------------------------------------------


 
nuf=work_cap_para; 
nustar=work_cap_para; 
nux=work_cap_para; 

%calculate no-indexation parameters
varkappad=1-kappad; 
varkappax=1-kappax; 
varkappamx=1-kappamx; 
varkappami=1-kappami; 
varkappamc=1-kappamc; 


%some simple transformations
muz=1+muzPercent/100; 
%mupsi=1+mupsiPercent/100;
% get mupsi residually, so that muzplus is always the same (and must be given in .mod-file)
mupsi=(muzplus/muz)^((1-alpha)/alpha); 

sigmaL= sig_l_C; % Estaba sig_l_C; %Estaba 10*0.2 *** sigmaLScaled*10; 



%Inflation rates
pic=pitarget;
pibar=pic;
pimx=pibar;
pimc=pibar;
pimi=pibar;
pii=pibar/mupsi;
piw=muzplus*pibar;
pix=pistar;       



    
    
 czcap = czcapbis/(1-czcapbis);
 h_E = h;
 h_NR = h;
 sig_l_D = sig_l_C;
 sig_l_C_NR = sig_l_C;
 sig_l_D_NR = sig_l_D;
 xi_w_C_NR = xi_w_C;
 gamma_w_C_NR = gamma_w_C; 
 gamma_w_D = gamma_w_C; 
 xi_w_D_NR = xi_w_D;
 gamma_w_D_NR = gamma_w_D; 
 MCSS = (1-tauSS)/(mu*(1-subv));
 MCDSS = (1-tauSS)/(mu_D*(1-subv_D));
 RSS = (1/betta-1)/(mu_R_D*(1-subv_R_D));
 RBDSS = RSS; 
 
 RB_LSS = (0.6/(4*100) + 1)*RSS;
 
 RDSS = (RBDSS)*mu_R_D*(1-subv_R_D); 
 RLSS = (RB_LSS)*mu_R_L*(1-subv_R_L);
 RLESS = (RB_LSS)*mu_R_L_E*(1-subv_R_L_E);
 RLLSS = (1+RLSS)*OMEGHHSS/ G_OMEGHHNS  - 1;
 RLLESS = (1+RLESS)*OMEGSS/ G_OMEGNS  - 1 ;
 R_KSS = 1/betta_NR_E - (1-tau) - (1-tau)*(1-chi_NR_E)*(H_OMEGNS  + G_OMEGNS *Y_OMEGS );                                            
 ATCUSS = 1/czcap*R_KSS*(exp(czcap*(TCUSS-1))-1);
 ATCU1SS = R_KSS*exp(czcap*(TCUSS-1));
 WSS = (MCSS*R_KSS^(-alph)*alph^alph*(1-alph)^(1-alph))^(1/(1-alph));
 TDSS = mu_D*(1-subv_D)*WSS^(1-alph_D-alph_LAN)*R_KSS^(alph_D)/((alph_D^alph_D)*(1-alph_D-alph_LAN)^(1-alph_D-alph_LAN))*(PLSS/alph_LAN)^alph_LAN;
 KLSS = alph/(1-alph)*WSS/R_KSS;
 KLDSS = alph_D/(1-alph_D-alph_LAN)*WSS/R_KSS;
 DCSS = omega_D/(1-omega_D)*(TDSS*(1-betta*(1-tau_D)))^(-hetha_D)*(1-betta*h)^(-hetha_D)*(1-h);
 DCNRSS = omega_D/(1-omega_D)*(TDSS*(1 - betta_NR*(1-tau_D) - betta_NR*(1-tau_D)*(1-chi_NR)*(H_OMEGHHNS  + G_OMEGHHNS *Y_OMEGHHS )))^(-hetha_D)*(1-betta_NR*h_NR)^(-hetha_D)*(1-h_NR) ;  
 LAND_LDSS = (WSS/PLSS)*(alph_LAN/(1-alph_D-alph_LAN)); 
 ZLSS = KLSS^alph/ phi_y;
 ZLDSS = (KLDSS^alph_D)*(LAND_LDSS^alph_LAN)/ phi_y_D;

%

% Exchange rate growth and return on capital
s=pic/pistar;



% % Nominal Interest Rate
Rbss=1+RSS;

% set all working capital parameters to the one common estimated value
% parameters nuf work_cap_para varkappad kappad varkappax kappax varkappamx
% kappamx varkappami kappami varkappamc kappamc varkappaw kappaw muz muzPercent
% mupsi muzplus alpha sigmaL sigmaLScaled pitarget pistar beta

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%World Nominal Interest Rate
Rstar= (muzplus/beta-taub)/(1-taub)*pistar;

%Working Capital Interest Rates
Rnustar=nustar*Rstar+1-nustar;
Rf=nuf*Rbss+1-nuf;
Rx=nux*Rbss+1-nux;

%Nonlinear pricing domestic intermediate
pitilded=pibar^kappad*pitarget^(1-kappad-varkappad)*pibreve^varkappad;


phalo=((1-xid*(pitilded/pibar)^(1/(1-lambdad)))/(1-xid))^(1-lambdad)...
    /((1-xid*(pitilded/pibar)^(lambdad/(1-lambdad)))/(1-xid))^((1-lambdad)/lambdad);


%Nonlinear pricing exporters
pitildex=pix^kappax*pix^(1-kappax-varkappax)*pibreve^varkappax;

mcx=1/lambdax*((1-xix*(pitildex/pix)^(1/(1-lambdax)))/(1-xix))^((1-lambdax))...
    *(1-beta*xix*(pitildex/pix)^(lambdax/(1-lambdax)))...
    /(1-beta*xix*(pitildex/pix)^(1/(1-lambdax)));


phalox=((1-xix*(pitildex/pix)^(1/(1-lambdax)))/(1-xix))^(1-lambdax)...
    /((1-xix*(pitildex/pix)^(lambdax/(1-lambdax)))/(1-xix))^((1-lambdax)/lambdax);


%Nonlinear pricing consumption importer
pitildemc=pimc^kappamc*pitarget^(1-kappamc-varkappamc)*pibreve^varkappamc;

mcmc=1/lambdamc*((1-ximc*(pitildemc/pimc)^(1/(1-lambdamc)))/(1-ximc))^((1-lambdamc))...
    *(1-beta*ximc*(pitildemc/pimc)^(lambdamc/(1-lambdamc)))...
    /(1-beta*ximc*(pitildemc/pimc)^(1/(1-lambdamc)));

phalomc=((1-ximc*(pitildemc/pimc)^(1/(1-lambdamc)))/(1-ximc))^(1-lambdamc)...
    /((1-ximc*(pitildemc/pimc)^(lambdamc/(1-lambdamc)))/(1-ximc))^((1-lambdamc)/lambdamc);

%Nonlinear pricing investment importer
pitildemi=pimi^kappami*pitarget^(1-kappami-varkappami)*pibreve^varkappami;

mcmi=1/lambdami*((1-ximi*(pitildemi/pimi)^(1/(1-lambdami)))/(1-ximi))^((1-lambdami))...
    *(1-beta*ximi*(pitildemi/pimi)^(lambdami/(1-lambdami)))...
    /(1-beta*ximi*(pitildemi/pimi)^(1/(1-lambdami)));

phalomi=((1-ximi*(pitildemi/pimi)^(1/(1-lambdami)))/(1-ximi))^(1-lambdami)...
    /((1-ximi*(pitildemi/pimi)^(lambdami/(1-lambdami)))/(1-ximi))^((1-lambdami)/lambdami);

%Nonlinear pricing export importer
pitildemx=pimx^kappamx*pitarget^(1-kappamx-varkappamx)*pibreve^varkappamx;

mcmx=1/lambdamx*((1-ximx*(pitildemx/pimx)^(1/(1-lambdamx)))/(1-ximx))^((1-lambdamx))...
    *(1-beta*ximx*(pitildemx/pimx)^(lambdamx/(1-lambdamx)))...
    /(1-beta*ximx*(pitildemx/pimx)^(1/(1-lambdamx)));

phalomx=((1-ximx*(pitildemx/pimx)^(1/(1-lambdamx)))/(1-ximx))^(1-lambdamx)...
    /((1-ximx*(pitildemx/pimx)^(lambdamx/(1-lambdamx)))/(1-ximx))^((1-lambdamx)/lambdamx);

              pmc=taumc*Rnustar*varphi/mcmc;
  pmx=taumx*Rnustar*varphi/mcmx;
  pmi=taumi*Rnustar*varphi/mcmi;

%Relative consumption price
 pc=(1-omegac+omegac*pmc^(1-etac))^(1/(1-etac));
  
 %Relative investment price
 pinvest=(1-omegai+omegai*pmi^(1-etai))^(1/(1-etai));

 %Relative export price
 px=(taux*Rx/(mcx*varphi))*(omegax*pmx^(1-etax)+1-omegax)^(1/(1-etax));

 %
 
cte1 = (1-omegac)*(pc)^(etac);
cte2 = (1-omegai)*(pinvest)^(etai);
cte3 = (omegax*pmx^(1-etax)+1-omegax)^(etax/(1-etax))*  ...   
        (1-omegax)*(phalox)^( lambdax/(1-lambdax))*px^(-etaf);

    options = optimset('Display','off');
x  = fsolve(@(x)prometheo_solve(x,ZLSS,ZLDSS,KLSS,KLDSS,DCSS,DCNRSS,tau,tau_D,omega_NR,GSS,GDSS,CECSS,cte1,cte2,cte3,...
                             varphi,taumx,Rnustar,mcmx,taumc,mcmc,taumi,mcmi,...
                             omegac,etac,omegai,etai,taux,Rx,mcx,omegax,etax,etaf,phalox,lambdax),[ 0.5; 0.5; 10],options);
CSS = x(1); 
LCSS = x(2); 
ystar = x(3);


%%
                 
 CESS = CECSS*CSS;
 KCSS = KLSS*LCSS;
 KDSS = KLDSS*(1-LCSS);
 KSS =KCSS + KDSS;
 ISS = tau*(KLSS*LCSS + KLDSS*(1-LCSS));
 LANDSS = LAND_LDSS*(1-LCSS);
 ZSS = KCSS^alph*LCSS^(1-alph) / phi_y;
 ZDSS = KDSS^alph_D*(1-LCSS)^(1-alph_D-alph_LAN)*LANDSS^alph_LAN/ phi_y_D;

 YSS = (CECSS*CSS+cte1*CSS + GSS*ZLSS*LCSS + cte2*tau*KLSS*LCSS +cte2*tau*KLDSS*(1-LCSS) +cte3*ystar);
 ybar = YSS;
 DSS = DCSS*CSS;
 DNRSS = DCNRSS*CSS;
 
 % -------------------------------------------------------------------
 DebtSS = (1-chi_NR)*TDSS*(1-tau_D)*DNRSS/(1+RLSS)*G_OMEGHHNS ;  
 TRSS = CSS + TDSS*(DNRSS - (1-tau_D)*DNRSS) - H_OMEGHHNS *(1-chi_NR)*(1-tau_D)*TDSS*DNRSS - DebtSS - WSS;
 UCbisESS = (CESS*(1-h_E))^(-sig_c_E);
 UCESS = (1-betta_NR_E*h_E)*UCbisESS;
 DebtESS = G_OMEGNS*(1-chi_NR_E)*(1-tau)*(KCSS + KDSS)/(1+RLESS) ; 
 TRESS = CESS + tau*KCSS + tau*KDSS - H_OMEGNS *(1-chi_NR_E)*(1-tau)*(KCSS + KDSS) - DebtESS - MCSS*ZSS - MCDSS*ZDSS + WSS ;
 DebtTOTSS = omega_NR*DebtSS + DebtESS;

 % ------------------------------------------------------------------------
 R_LL = (1+RLSS)*OMEGHHSS/G_OMEGHHNS  - 1;
 R_LL_E = (1+RLESS)*OMEGSS/ G_OMEGNS  - 1 ;
 EE_SIG = 0; EE_SIG_HH = 0;
 E_Omega_HH = normcdf( Z_OMEGHHS - sigma_HH*exp(EE_SIG_HH) );  
 E_Omega_E = normcdf( Z_OMEGS - sigma*exp(EE_SIG) ); 
 PD_HH = normcdf(Z_OMEGHHS) ;
 PD_E = normcdf(Z_OMEGS) ; 
 PI = 0 ;
 Q_H_NR = 1; 
 Q = 1; 
 Q_D = 1;
 D = DSS; T_D = TDSS;
 DNR = DNRSS;
 Debt = DebtSS; 
 Debt_E = DebtESS;
 K_C = KCSS; K_D = KDSS;
 LGD_H = (1+R_LL)/(1+PI)*(1-(1-mu_HH )*(E_Omega_HH/PD_HH)*((1-chi_NR)*(1-tau_D)*(Q_H_NR*T_D*DNR)/Debt));
 LGD_E = (1+R_LL_E)/(1+PI)*(1-(1- mu_NFC)*(E_Omega_E/PD_E)*((1-chi_NR_E)*(1-tau)*( Q*K_C + Q_D*K_D )/Debt_E)); 
 APR = omega_NR*DebtSS*apr_h(PD_HH,LGD_H) + DebtESS*apr_e(PD_E,LGD_E);
 
 kappaB = 100*1/12;
 BankcapSS = DebtTOTSS/kappaB;
 DepoSS = DebtTOTSS - BankcapSS;        
 
 PiR_D = (RSS - RDSS)*DepoSS;
 RB_L = (0.6/(4*100) + 1)*RSS;
 PiR_B = (RLSS - RB_L)*omega_NR*DebtSS + (RLESS - RB_L)*DebtESS;
 OMEG_B = (RSS*(kappaB  - 1) - PiR_D/BankcapSS - PiR_B/BankcapSS)/( RB_L*kappaB );
 OMEG_B_v = OMEG_B/(1 - nu_b*APR/DebtTOTSS);
 
 syms x
 eqn = ( log(OMEG_B_v) + 0.5*x.^2 )/x == norminv(1-((1 - 0.1507)^(1/4)));
 sigma_B = vpasolve(eqn, x, [0 2]);
   
 
 EE_SIG_B = 0;
 Z_OMEG_B = ( log(OMEG_B) + 0.5*sigma_B^2*(exp(EE_SIG_B*2) ) ) / (sigma_B*exp(EE_SIG_B));
 Z_OMEG_B_v = ( log(OMEG_B_v) + 0.5*sigma_B^2*(exp(EE_SIG_B*2) ) ) / (sigma_B*exp(EE_SIG_B));  
 PD_B = normcdf(Z_OMEG_B);
 E_Omega_B = normcdf( Z_OMEG_B - sigma_B*exp(EE_SIG_B)); 
 GammaB = (1 - normcdf(Z_OMEG_B) )*OMEG_B  + E_Omega_B ;
 chiB = ( RB_L*(1 - E_Omega_B) - RSS*(1 - PD_B) )/...
        (...
         normcdf(Z_OMEG_B_v) - PD_B + ...
        (RSS/RB_L - OMEG_B)*( ...
         normpdf(Z_OMEG_B_v)/(1- nu_b*APR/DebtTOTSS )...
                                - normpdf(Z_OMEG_B)...
         ));
                        
                                
                        
 zetab =  inv(RB_L*kappaB*(1-GammaB) - chiB*(normcdf(Z_OMEG_B_v) - PD_B));
 
 % ----------------------------------------------------------------
 
 XSS = ((1-omega_D)^(1/hetha_D)*(CSS-h*CSS)^((hetha_D-1)/hetha_D)+omega_D^(1/hetha_D)*DSS^((hetha_D-1)/hetha_D))^(hetha_D/(hetha_D-1));
 XNRSS = ((1-omega_D)^(1/hetha_D)*(CSS-h_NR*CSS)^((hetha_D-1)/hetha_D)+omega_D^(1/hetha_D)*DNRSS^((hetha_D-1)/hetha_D))^(hetha_D/(hetha_D-1));
 UCbisSS = XSS^(-sig_c);
 UCbisNRSS = XNRSS^(-sig_c);
 UCSS = (1-betta*h)*UCbisSS*(1-omega_D)^(1/hetha_D)*(CSS/XSS)^(-1/hetha_D)*(1-h)^(-1/hetha_D);
 UC_DSS = (omega_D)^(1/hetha_D)*(DSS/XSS)^(-1/hetha_D)*UCbisSS;                                                                                 
 UCNRSS = (1-betta_NR*h_NR)*(1-omega_D)^(1/hetha_D)*(CSS/XNRSS)^(-1/hetha_D)*(1-h_NR)^(-1/hetha_D)*UCbisNRSS;
 UC_DNRSS = (omega_D)^(1/hetha_D)*(DNRSS/XNRSS)^(-1/hetha_D)*UCbisNRSS;
 ZP1_DSS = UCSS*MCDSS*ZDSS*TDSS/(1-betta*xi_p_D);
 ZP2_DSS = (1-tauSS)*UCSS*ZDSS*TDSS/(1-betta*xi_p_D);
 ZP1SS = UCSS*MCSS*YSS/(1-betta*xi_p);
 ZP2SS = (1-tauSS)*UCSS*YSS/(1-betta*xi_p);
 WTSS = omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR)*WSS;
 NCSS = LCSS/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR));
 NDSS = (1-LCSS)/(omega_NR^omega_NR*(1-omega_NR)^(1-omega_NR));
 WTILD_CSS = WTSS; 
 WTILD_DSS = WTSS;
 WTILD_CNRSS = WTSS; 
 WTILD_DNRSS = WTSS;
 LC_BAR = (1-tauwSS)*UCSS*WTILD_CSS/(muw_C*(1-subvw))*(NCSS)^(-sig_l_C);
 LD_BAR = (1-tauwSS)*UCSS*WTILD_DSS/(muw_D*(1-subvw))*(NDSS)^(-sig_l_D);
 LC_NR_BAR = (1-tauwSS)*UCNRSS*WTILD_CNRSS/(muw_C*(1-subvw))*(NCSS)^(-sig_l_C_NR);
 LD_NR_BAR = (1-tauwSS)*UCNRSS*WTILD_DNRSS/(muw_D*(1-subvw))*(NDSS)^(-sig_l_D_NR);
 ZW1CSS = LC_BAR*NCSS^(1+sig_l_C)*WTSS^(muw_C/(muw_C-1))/(1-betta*xi_w_C);
 ZW1DSS = LD_BAR*(NDSS)^(1+sig_l_D)*WTSS^(muw_D/(muw_D-1))/(1-betta*xi_w_D);
 ZW2CSS = (1-tauwSS)*(UCSS)*NCSS*WTSS^(muw_C/(muw_C-1))/(1-betta*xi_w_C);
 ZW2DSS = (1-tauwSS)*(UCSS)*(NDSS)*WTSS^(muw_D/(muw_D-1))/(1-betta*xi_w_D);
 ZWNR1CSS = LC_NR_BAR*NCSS^(1+sig_l_C_NR)*WTSS^(muw_C/(muw_C-1))/(1-betta_NR*xi_w_C_NR);
 ZWNR1DSS = LD_NR_BAR*(NDSS)^(1+sig_l_D_NR)*WTSS^(muw_D/(muw_D-1))/(1-betta_NR*xi_w_D_NR);
 ZWNR2CSS = (1-tauwSS)*(UCNRSS)*NCSS*WTSS^(muw_C/(muw_C-1))/(1-betta_NR*xi_w_C_NR);
 ZWNR2DSS = (1-tauwSS)*(UCNRSS)*(NDSS)*WTSS^(muw_D/(muw_D-1))/(1-betta_NR*xi_w_D_NR);
 WELFARESS = (XSS^(1-sig_c)/(1-sig_c) - LC_BAR*LCSS^(1+sig_l_C)/(1+sig_l_C)- LD_BAR*(1-LCSS)^(1+sig_l_D)/(1+sig_l_D))/(1-betta);
 WELFARENRSS = (XNRSS^(1-sig_c)/(1-sig_c) - LC_NR_BAR*LCSS^(1+sig_l_C_NR)/(1+sig_l_C_NR)- LD_NR_BAR*(1-LCSS)^(1+sig_l_D_NR)/(1+sig_l_D_NR))/(1-betta_NR);

R=RSS; R_K = R_KSS; C = CSS ; K = KSS; I = ISS ;  Z = ZSS ;  Z_D = ZDSS; MC_D = MCDSS; Y = YSS ;
L = LSS ; W = WSS ; MC = MCSS; ATCU1 = R_KSS ; UCbis = UCbisSS ; UC = UCSS;

ZP1 = ZP1SS ; ZP2 = ZP2SS ; 
PI_D = 0; Dp_D = 1; AP_D = 1; ZP1_D = ZP1_DSS; ZP2_D = ZP2_DSS; 
WELFARE = WELFARESS ;

 TCU_D = 1; ATCU_D= 0; ATCU1_D= R_KSS; SI_D= 0; SI1_D= 0; I_D = tau*KDSS; I_C=tau*KCSS; 
Q_H = 1; SI_H = 0; SI1_H = 0; EE_IH = 0; I_H = tau_D*DSS;  SI_H_NR = 0; SI1_H_NR = 0; I_H_NR = tau_D*DNRSS; 
C_E = CESS; UC_E = UCESS; UCbis_E = UCbisESS; PSI_E = PSIESS; EE_LTV_E = 0; 

UC_D = UC_DSS; WELFARENR = WELFARENRSS; X = XSS;  UCbisNR = UCbisNRSS; 
XNR = XNRSS;  UC_DNR = UC_DNRSS; UCNR = UCNRSS; CNR = CSS; PSI = PSISS; 
 L_C = LCSS; L_D = 1-LCSS; 

Dw_D = 1; Dw_C = 1; W_C = WSS; W_D = WSS; 
ZW1_C = ZW1CSS ;  ZW1_D = ZW1DSS ; ZW2_C = ZW2CSS ;  ZW2_D = ZW2DSS ; 
ZWNR1_C = ZWNR1CSS; ZWNR2_C = ZWNR2CSS; ZWNR1_D = ZWNR1DSS; ZWNR2_D = ZWNR2DSS;
W_C_S = WTSS; N_C_S = NCSS; W_C_NR = WTSS; N_C_NR = NCSS; AW_C_NR = 1; Dw_C_NR = 1; 
W_D_S = WTSS; N_D_S = NDSS; W_D_NR = WTSS; N_D_NR = NDSS; AW_D_NR = 1; Dw_D_NR = 1;


Dp = 1; AW_C = 1; AW_D = 1; AP = 1; 
TCU = 1; 

EE_A_D = 0; EE_P_D = 0; 
EE_A 	=	0	; EE_B 	=	0	; EE_G 	=	0	; EE_L 	=	0	; EE_I 	=	0	; EE_P 	=	0	; EE_Q 	=	0	;
EE_W 	=	0	; EE_LTV = 0; EE_H = 0; PI_BAR 	=	0	; 
Robs 	=	0	; Yobs 	=	0	; Zobs 	=	0	; Cobs 	=	0	; Iobs 	=	0	; Lobs 	=	0	;
CPIobs 	=	0	; Wobs 	=	0	; PIobs 	=	0	; PIgdpobs 	=	0	; Z_Dobs      =   0   ; 
T_Dobs      =   0   ; T_DdiffU = 0;
dDebtobs    =   0   ; Debtobs    =   0   ; 
E_F	=	0	; 
SI	=	0	; SI1	=	0	; CPI =	0	;  ATCU = 0; EE_R = 0; 


Z_Dobs = 0; PI_Dobs = 0; T_Dobs = 0; dDebtobs = 0; LAND = LANDSS; P_L = PLSS; 

CRobs = 0; CNRobs = 0; L_Cobs = 0; L_Dobs = 0; W_Cobs = 0; W_Dobs = 0; 
DRobs =0; DNRobs =0; 


Dp_R_D = 1; AR_D = 1; EE_R_D = 0; Depo = DepoSS; 
Z1_R_D = UCSS*DepoSS/mu_R_D/(1-subv_R_D)/(1-betta*xi_R_D); Z2_R_D = UCSS*DepoSS/(1-betta*xi_R_D);
Dp_R_L = 1; AR_L = 1; EE_R_L = 0;   
Z1_R_L = UCSS*DebtSS/mu_R_L/(1-subv_R_L)/(1-betta*xi_R_L); Z2_R_L = UCSS*DebtSS/(1-betta*xi_R_L);
Dp_R_L_E = 1; AR_L_E = 1; EE_R_L_E = 0 ; 
Z1_R_L_E = UCSS*DebtESS/mu_R_L_E/(1-subv_R_L_E)/(1-betta*xi_R_L_E); Z2_R_L_E = UCSS*DebtESS/(1-betta*xi_R_L_E); 
RB_D = RBDSS; 

R_D = (RBDSS)*mu_R_D*(1-subv_R_D); 
R_L = (RB_L)*mu_R_L*(1-subv_R_L);  
R_L_E = (RB_L)*mu_R_L_E*(1-subv_R_L_E); 

Bankcap = BankcapSS; Debt_TOT = DebtTOTSS; 
R_Lobs = 0; R_Dobs = 0; RB_Lobs = 0; R_L_Eobs = 0; RB_Dobs = 0; Debt_Eobs = 0; dDebt_Eobs = 0;Debt_TOTobs = 0; Bankcapobs = 0; 
LEV = DebtTOTSS/BankcapSS;
RCG = 100*BankcapSS/DebtTOTSS;
LEVobs = 0;
EE_Bankcap = 0;
EE_Bankcapbis = 0;


SB_Lobs = 0; 
Depoobs = 0;
dDepoobs = 0;

 H_OMEG = H_OMEGN; G_OMEG =G_OMEGN; EFP_OMEG = Y_OMEG; OMEG = OMEGSS;


OMEG_HH = OMEGHHSS; EE_SIG_HH = 0; H_OMEG_HH = H_OMEGHHN; G_OMEG_HH = G_OMEGHHN; EFP_OMEG_HH = Y_OMEGHH;

EE_SIG_HH = 0; 


R_LLobs = 0;
R_LL_Eobs = 0;
S_LLobs = 0;
S_LL_Eobs = 0;

PD_HHobs = 0;
PD_Eobs = 0;



%%            %Relative import prices
            pmx=taumx*Rnustar*varphi/mcmx;
            pmc=taumc*Rnustar*varphi/mcmc;
            pmi=taumi*Rnustar*varphi/mcmi;

            %Relative consumption price
            pc=(1-omegac+omegac*pmc^(1-etac))^(1/(1-etac));

            %Relative investment price
            pinvest=(1-omegai+omegai*pmi^(1-etai))^(1/(1-etai));

            %Relative export price
            px=(taux*Rx/(mcx*varphi))*(omegax*pmx^(1-etax)+1-omegax)^(1/(1-etax));

            
            q=varphi/pc;
            i=I;% Estaba kbar*(1-(1-delta)/(muzplus*mupsi))/Upsilon;
            x=px^(-etaf)*ystar;
  
            psizplus=UC; % Estaba (zetac*(muzplus-beta*b)/(muzplus-b))/(c*pc*(1+tauc));

            im=omegai*(pinvest/pmi)^(etai)*I; % Estaba omegai*(pinvest/pmi)^(etai)*i // I = I_C + I_D; 
            xm=omegax*(1/pmx*(omegax*pmx^(1-etax)+1-omegax)^(1/(1-etax)))^etax...
                *phalox^(-lambdax/(lambdax-1))*px^(-etaf)*ystar;
            cms=omegac*(pc/pmc)^(etac)*C; % Estaba omegac*(pc/pmc)^(etac)*c
            cmb=omegac*(pc/pmc)^(etac)*CNR; 
            cm=(1-omega_NR)*cms + omega_NR*cmb;
            lcmsU = log(cms);
            lcmbU = log(cmb);
            lcsU = log(C);
            lcbU = log(CNR);
            mc = MC;
            %nonlinear pricing variables
            Kd=lambdad*psizplus*ybar*mc/(1-beta*xid*(pitilded/pibar)^(lambdad/(1-lambdad)));
            Fd=psizplus*ybar/(1-beta*xid*(pitilded/pibar)^(1/(1-lambdad)));

            Kx=lambdax*psizplus*varphi*px*x*mcx/(1-beta*xix*(pitildex/pix)^(lambdax/(1-lambdax)));
            Fx=psizplus*varphi*px*x/(1-beta*xix*(pitildex/pix)^(1/(1-lambdax)));

            Kmc=lambdamc*psizplus*pmc*mcmc*cm/(1-beta*ximc*(pitildemc/pimc)^(lambdamc/(1-lambdamc)));
            Fmc=psizplus*pmc*cm/(1-beta*ximc*(pitildemc/pimc)^(1/(1-lambdamc)));

            Kmi=lambdami*psizplus*pmi*mcmi*im/(1-beta*ximi*(pitildemi/pimi)^(lambdami/(1-lambdami)));
            Fmi=psizplus*pmi*im/(1-beta*ximi*(pitildemi/pimi)^(1/(1-lambdami)));

            Kmx=lambdamx*psizplus*pmx*mcmx*xm/(1-beta*ximx*(pitildemx/pimx)^(lambdamx/(1-lambdamx)));
            Fmx=psizplus*pmx*xm/(1-beta*ximx*(pitildemx/pimx)^(1/(1-lambdamx)));

            %Creating Pitilde/Pi ratio variables
            pitildedpi=pitilded/pibar;
            pitildexpi=pitildex/pix;
            pitildemcpi=pitildemc/pimc;
            pitildemipi=pitildemi/pimi;
            pitildemxpi=pitildemx/pimx;
                       
            data_pid=400*log(pibar);
            data_R=400*(Rbss-1);
            data_wdiff=0 ;
            data_cdiff=0;
            data_idiff=0;
            data_qdiff=0;
            data_Hdiff=0;
            data_ydiff=0;
            data_xdiff=0;
            data_impdiff=0;
            data_pic=400*log(pic);
            data_pii=400*log(pii);
            data_ystardiff=0;
            data_pistar=400*log(pistar);
            data_Rstar=400*(Rstar-1);
            data_gdiff=0;
            
            data_Hhat=0;
            nxdivGDP = 0;
            GDP12q_diff=12*100*log(muzplus);
            GDP4q_diff=4*100*log(muzplus);
            pic4q=data_pic;
            

lmcU=log(mc); 
lRfU=log(Rf);
lpxU=log(px);
lpixU=log(pix);
lRnustarU=log(Rnustar); 
lpiU=log(pibar); 
lmcxU=log(mcx);
lpimcU=log(pimc);
lmcmcU=log(mcmc);
lpimxU=log(pimx);
lmcmxU=log(mcmx);
lpimiU=log(pimi); 
lmcmiU=log(mcmi); 
lpicU=log(pic); 
lpmcU=log(pmc); 
lpiiU=log(pii);
lpmiU=log(pmi);
liU=log(i);
lpsizplusU=log(psizplus); 
lpinvestU=log(pinvest);
lsU=log(s); 
 
lqU=log(q);
lxU=log(x); 
lpcU=log(pc);
lRU=log(Rbss); 
 
lRxU=log(Rx); 
lpmxU=log(pmx);
StildeU=0; 
SprimetildeU=0;
lmuzplusU=log(muzplus); 
lepsilonU =log(epsilon);  
lmupsiU =log(mupsi);  
lpitargetU =log(pibar);  
lUpsilonU =log(Upsilon);  
lzetacU =log(zetac);    
lRstarU =log(Rstar);  
phitildeU =0;  
ltauyU =log(tauy);    
lzetahU =log(zetah);  
lystarU =log(ystar);   
lpistarU =log(pistar);  

lmuzU=log(muz);


data_pidU=400*log(pibar);
data_wdiffU=0;
data_cdiffU=0;
data_idiffU=0;
data_qdiffU=0;    
data_HdiffU=0;
data_ydiffU=0;
data_ldiffU=0;
data_xdiffU=0;
data_impdiffU=0;
data_picU=400*log(pic);
data_piiU=400*log(pii);
data_ystardiffU=0;
data_pistarU=400*log(pistar);
data_gdiffU=0;
lpitildedpiU=log(pitildedpi);
lphaloU=log(phalo); 
lpitildexpiU=log(pitildexpi);
lKxU=log(Kx);
lFxU=log(Fx);
lphaloxU=log(phalox);
lpitildemcpiU=log(pitildemcpi);
lKmcU=log(Kmc);
lFmcU=log(Fmc);
lphalomcU=log(phalomc);
lcmU=log(cm);
lpitildemipiU=log(pitildemipi);
lKmiU=log(Kmi);
lFmiU=log(Fmi);
lphalomiU=log(phalomi);
limU=log(im);
lpitildemxpiU=log(pitildemxpi);
lKmxU=log(Kmx);
lFmxU=log(Fmx);
lphalomxU=log(phalomx);
lxmU=log(xm);





ltaudU=log(taud);
ltauxU=log(taux);
ltaumcU=log(taumc);
ltaumiU=log(taumi);
ltaumxU=log(taumx);



   
lyU=log(Y); 
ybar = Y;

lKdU=log(Kd);
lFdU=log(Fd);
a=etaa*ybar;
aU = a;

Slev=1;
lSlevU=log(Slev);

nxdivGDP = 0;
nxdivGDPU = nxdivGDP;

data_RU=400*(exp(lRU)-Rbss);
data_RstarU=400*(exp(lRstarU)-Rstar);


        DebtE_Tot = Debt_E + ...
                    nustar*(exp(lqU+lpcU)*( ...
                            exp(lcmU+(lambdamc/(1-lambdamc))*lphalomcU) ...
                           +exp(limU+(lambdami/(1-lambdami))*lphalomiU) ...
                           +exp(lxmU+(lambdamx/(1-lambdamx))*lphalomxU) ...
                           )) + ...
                    nux*(  exp(lpmxU)* ...
                                     (omegax)  * ((omegax*exp(lpmxU)^(1-etax)+1-omegax)^(1/(1-etax))/exp(lpmxU))^(etax)* ...    
                                               exp(lphaloxU*lambdax/(1-lambdax))*exp(lpxU)^(-etaf)*exp(lystarU) +...
                                     (1-omegax)*(omegax*exp(lpmxU)^(1-etax)+1-omegax)^(etax/(1-etax))*     ...
                                               exp(lphaloxU*lambdax/(1-lambdax))*exp(lpxU)^(-etaf)*exp(lystarU)...
                           ) ;




lHU = log(L);
lwbarU = log(W);
lpiU = log(1 + PI) ;
Profit_BdiffU = 0;

 CDom = (1-omega_NR)*(1-omegac)*(exp(lpcU))^(etac)*C ... 
                 +   omega_NR  *(1-omegac)*(exp(lpcU))^(etac)*CNR; 
 CDomSS = CDom;
             CDomObs = 0;
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            
NumberOfEndogenousVariables = M_.endo_nbr;
  ys = zeros(NumberOfEndogenousVariables,1);
  for i = 1:NumberOfEndogenousVariables
    varname = deblank(M_.endo_names(i,:));
    eval(['ys(' int2str(i) ') = ' varname ';']);
  end

  
  NumberOfParameters = M_.param_nbr;
  for i = 1:NumberOfParameters
    paramname = deblank(M_.param_names(i,:)); 
    eval([  'M_.params(' int2str(i) ')=' paramname ';']);    
  end

   
